;	TITLE '(C) TFT RSSI POWER METER 10/11/2017

;-----------------------------------------------------------------------------
       .equ __30F4012, 1
       .include "p30f4012.inc"
;..............................................................................
;      .section .myconstbuffer, psv
;..............................................................................
;Code Section in Program Memory
;-----------------------------------------------------------------------------        
;	Configuration bits
;--------------------------------------------------------
	config __FOSC, CSW_FSCM_OFF & FRC_PLL8
	config __FWDT,WDT_OFF
	config __PBORPOR, PBOR_OFF & MCLR_EN
	config __FGS, CODE_PROT_OFF
;..............................................................................
        .section .myconstbuffer, psv
;------------------------------------------------------
;	   	    		28 PIN DIL 
;					dsPIC30F4012
;                     ______  ______
;		  			 |      \/      |
;   PROGRAMER/MCLR --+ 1         28 +-- RB7  AVdd	
;	            	 |              |
;              RB0 --+ 2         27 +-- RB6  AVss
;	           		 |              |
;              RB1 --+ 3         26 +-- RE0		
;	           		 |              |
;              RB2 --+ 4         25 +-- RE1
;	          		 |              |
;    	       RB3 --+ 5         24 +-- RE2
;	           		 |              |
;   	       RB4 --+ 6         23 +-- RE3
;	                 |               |
;              RB5 --+ 7         22 +-- RE4
;	                 |              |
;              VSS  -+ 8         21 +-- RE5
;	                 |              |
;              OSC --+ 9         20 +-- VDD
;	                 |              |
;             RC15 --+ 10        19 +-- VSS
;	                 |              |
;	 	      RC13 --+ 11        18 +-- RC7/PGC	
;	                 |              |
;	          RC14 --+ 12        17 +-- RC6/PGD
;	                 |              |
;              VDD --+ 13        16 +-- RE8
;	                 |              |
;              RD1 --+ 14        15 +-- RD0	       	
;                    |______________|
;;define constant
;PORTB
	.equ	SCLK,2
	.equ	MISO,3
	.equ	MOSI,4
	.equ	IRQ,5
;PORTC
	.equ	TIMER,14
;PORTD
	.equ	OUT1,#1
	.equ	DIR,#0
;PORTE
	.equ	CE1,2
	.equ	CE0,3
	.equ	RST,4
	.equ	DC,5
;---- Useful Colours ---------------------------------------------------
	.equ	BLACK,  0x0000	;	
	.equ	BROWN,	0x7880	;
	.equ	RED,    0xF800	;
	.equ	ORANGE,	0xE380	;	
	.equ    YELLOW, 0xFFE0	;
	.equ    GREEN,  0x07E0	;
	.equ    BLUE,   0x001F	;
	.equ	VIOLET, 0xF8FF	;
	.equ	GREY,	0xCCC0 	;
	.equ    WHITE,  0xFFFF	;  	
;------ I/O Port constants -----------------------------
;define ram assignments
		.bss	saved,2
		.bss	T1_Ticks,2
		.bss	count,2
		.bss	temp,2
		.bss	temp1,2
		.bss	temp2,2
		.bss	temp3,2	
		.bss	temp4,2
		.bss	temp5,2
		.bss	datbuff,2
	    .bss    Hx,2
	   	.bss    Hy,2
	   	.bss    Hz,2
		.bss	rl0,2
		.bss	rl1,2
		.bss	test,2
		.bss	digit1,2
		.bss	digit2,2
		.bss	digit3,2
		.bss	digit4,2
		.bss	digit5,2
		.bss	digit6,2	
		.bss	preangle,2	
		.bss	angle,2
		.bss	prevangle,2
		.bss	preanglelast,2
		.bss	touchflg,2	
		.equ	delay1,2	
		.bss	pre1,2
		.bss	pre2,2
		.bss	pre3,2	
		.bss	pre4,2
		.bss	pre5,2
		.bss	pre6,2
		.bss	pre7,2	
		.bss	pre8,2	
		.bss	rlyflg,2	
		.bss	AC1,2
		.bss	AC2,2	
		.bss	AC3,2
		.bss	AC4,2	
		.bss	AC5,2
		.bss	AC6,2
		.bss	B1,2
		.bss	B2,2
		.bss	B3,2
		.bss	B4,2
		.bss	B5,2
		.bss	B6,2
		.bss	B7,2
		.bss	MB,2
		.bss	MC,2	
		.bss	MD,2
		.bss	UT,2	
		.bss	UP,2
		.bss	X1,2
		.bss	X2,2
		.bss	TEMP,2
		.bss	PRESSURE,2
		.bss	slowspeed,2	
		.bss	y1,2
		.bss	y2,2
		.bss	y3,2
		.bss	y4,2
		.bss	y5,2
		.bss	y6,2
		.bss	x1,2
		.bss	x2,2
		.bss	x3,2
		.bss	x4,2
		.bss	x5,2
		.bss	x6,2
		.bss	yy,2
		.bss	yyyy,2
		.bss	adval,2
		.bss	ad1,2
		.bss	ad2,2
		.bss	ad3,2
		.bss	ad4,2
		.bss	dBm,2	
;------------------------- vector tables ----------------
		.global __reset
;-------------------------------------------------------
		.text	;start of code
;-----------------------------------------	
__T1Interrupt:
		bclr	IFS0,#T1IF
		retfie
;-----------------------------------------
__reset:
	mov 	#__SP_init, W15       	;Initalize the Stack Pointer
	mov 	#__SPLIM_init, W0     	;Initialize the Stack Pointer Limit Register
	mov 	W0, SPLIM
	nop                             ;Add NOP to follow SPLIM initialization
	mov     #0xfffe,w0
	mov     w0,ADPCFG
	clr     LATB
	clr     LATC
	clr     LATD
	clr     LATE
	bset    CORCON, #PSV            ;Enable Program Space Visibility
;----------------------- Initialisation Routine -----------------------
init:
	rcall	init_ports	
   	rcall   InitialiseTouch
	rcall	InitialiseLCD
	rcall	init_ad
	clr     angle
	clr		preangle
	clr		preanglelast
	clr		digit4
	clr		digit5
	clr		digit6
	clr		touchflg
	call	InitialiseTouch
	mov		#0,w0
	mov		w0,y1
	mov		#0,w0
	mov		w0,y2
	mov		#0,w0
	mov		w0,y3
	mov		#0,w0
	mov		w0,y4
	mov		#0,w0
	mov		w0,y5
	mov		#0,w0
	mov		w0,y6
;-------------------- set up routines -----------------
    ;Draw Background Colour
   	mov   	#BLACK,w8	  				
	rcall   DrawBackground	
	mov		#YELLOW,w8
	mov		#20,w9		;X1
	mov		#200,w10	;Y1
	mov		#120,w11	;X2
	mov		#250,w12	;Y2	
	rcall	DrawRectangle			
	mov		#130,w9		;X1
	mov		#200,w10	;Y1
	mov		#230,w11	;X2
	rcall	DrawRectangle			
	mov		#240,w9		;X1
	mov		#200,w10	;Y1
	mov		#420,w11	;X2	
	rcall	DrawRectangle
	
	mov		#WHITE,w8
	mov		#68,w9
	mov		#50,w10
	mov		#70,w12
	rcall	DrawVerticalLine	
	add		#68,w9
	mov		#50,w10
	mov		#70,w12
	rcall	DrawVerticalLine	
	add		#68,w9
	mov		#50,w10
	mov		#70,w12
	rcall	DrawVerticalLine	
	add		#68,w9
	mov		#50,w10
	mov		#70,w12
	rcall	DrawVerticalLine	
	add		#68,w9
	mov		#50,w10
	mov		#70,w12
	rcall	DrawVerticalLine	
	add		#68,w9
	mov		#50,w10
	mov		#70,w12
	rcall	DrawVerticalLine	
	add		#68,w9
	mov		#50,w10
	mov		#70,w12
	rcall	DrawVerticalLine
	
	mov		#YELLOW,W8
	mov		#90,w10	;Y1
	mov		#60,W9		;X		
	mov		#0x31,w11
	rcall	DrawText
	add		#10,W9		;X		
	mov		#0x30,w11
	rcall	DrawText							
	add		#58,W9		;X		
	mov		#0x32,w11
	rcall	DrawText
	add		#10,W9		;X		
	mov		#0x30,w11
	rcall	DrawText					
	add		#58,W9		;X		
	mov		#0x33,w11
	rcall	DrawText
	add		#10,W9		;X		
	mov		#0x30,w11
	rcall	DrawText					
	add		#58,W9		;X		
	mov		#0x34,w11
	rcall	DrawText
	add		#10,W9		;X		
	mov		#0x30,w11
	rcall	DrawText					
	add		#58,W9		;X		
	mov		#0x35,w11
	rcall	DrawText
	add		#10,W9		;X		
	mov		#0x30,w11
	rcall	DrawText					
	add		#58,W9		;X		
	mov		#0x36,w11
	rcall	DrawText
	add		#10,W9		;X		
	mov		#0x30,w11
	rcall	DrawText				
	add		#50,W9		;X		
	mov		#0x37,w11
	rcall	DrawText	
	add		#10,W9		;X		
	mov		#0x30,w11
	rcall	DrawText									
	goto	main
;--------------------------------------------
header:						
	mov		#20,W9		;X
	mov		#300,W10	;Y	
	mov		#0x31,w11
	rcall	DrawBigText
	mov		#40,W9		;X
	mov		#0x30,w11
	rcall	DrawBigText	
	mov		#65,W9		;X
	mov		#0x2d,w11
	rcall	DrawBigText		
	mov		#80,W9		;X	
	mov		#0x47,w11
	rcall	DrawBigText	
	mov		#105,W9		;X
	mov		#0x48,w11
	rcall	DrawBigText
	mov		#125,W9		;X
	mov		#0x7a,w11
	rcall	DrawBigText	
	mov		#145,W9		;X		
	mov		#0x20,w11
	rcall	DrawBigText
	mov		#165,W9		;X		
	mov		#0x52,w11
	rcall	DrawBigText		
	mov		#190,W9		;X		
	mov		#0x53,w11
	rcall	DrawBigText	
	mov		#215,W9		;X		
	mov		#0x53,w11
	rcall	DrawBigText		
	mov		#240,W9		;X	
	mov		#0x49,w11
	rcall	DrawBigText		
	mov		#250,W9		;X		
	mov		#0x20,w11
	rcall	DrawBigText		
	mov		#270,W9		;X	
	mov		#0x44,w11
	rcall	DrawBigText	
	mov		#300,W9		;X	
	mov		#0x45,w11
	rcall	DrawBigText	
	mov		#325,W9		;X
	mov		#0x54,w11
	rcall	DrawBigText	
	mov		#350,W9		;X	
	mov		#0x45,w11
	rcall	DrawBigText	
	mov		#375,W9		;X	
	mov		#0x43,w11
	rcall	DrawBigText	
	mov		#400,W9		;X
	mov		#0x54,w11
	rcall	DrawBigText	
	mov		#420,W9		;X
	mov		#0x4f,w11
	rcall	DrawBigText	
	mov		#450,W9		;X	
	mov		#0x52,w11
	rcall	DrawBigText
	return			
;--------------------------------------------------------------------
main:
	mov		#YELLOW,W8	
	call	header
	call	calc
	mov		#RED,W8
	call	header
	call	calc
	mov		#BLUE,W8
	call	header
	call	calc
	mov		#GREEN,W8
	call	header
	call	calc
	mov		#WHITE,W8
	call	header
	call	calc
	mov		#ORANGE,W8	
	call	header
	call	calc
	mov		#VIOLET,W8	
	call	header
	call	calc	
	goto	main	
;-------------------------------------------------------------------	
calc:	
	mov		#0x400,w11
	mov		#BLACK,W8
	mov		#00,W9	;X
	mov		#30,W10	;Y	
	mov		#50,w12
	rcall	DrawFilledRectangle		
	call	get_ad
	mov		adval,w11
	sub		#140,w11
		
	mov		#RED,W8
	mov		#05,W9	;X
	mov		#30,W10	;Y	
	mov		#50,w12
	rcall	DrawFilledRectangle		 
  	mov		adval,w1	;A/D COUNT
  	mov		w1,dBm
  	mov 	#1000,w2 	;1000
 	repeat	#17
 	div.u   w1,w2	
  	mov		w0,ad1		
	mov 	#100,w2 	;100
 	repeat	#17
 	div.u   w1,w2	
 	mov		w0,ad2
 	mov 	#10,w2  	;10
 	repeat 	#17
 	div.u	w1,w2
 	mov 	w0,ad3
 	mov 	w1,ad4		
	mov		#WHITE,W8
	mov		#240,w10	;Y1
	mov		#28,W9		;X	
	mov		ad1,w11	
	add		#0x30,w11
	rcall	DrawFilledBigText		
	mov		#46,W9		;X	
	mov		ad2,w11	
	add		#0x30,w11
	rcall	DrawFilledBigText		
	mov		#65,W9		;X	
	mov		ad3,w11	
	add		#0x30,w11
	rcall	DrawFilledBigText	
	mov		#80,W9		;X	
	mov		ad4,w11	
	add		#0x30,w11
	rcall	DrawFilledBigText	
;------------ calc dBm ----------
	mov		dBm,w1
	sub		#130,w1
	mov 	#1000,w2 	;1000
 	repeat	#17
 	div.u   w1,w2	
  	mov		w0,ad1		
	mov 	#100,w2 	;100
 	repeat	#17
 	div.u   w1,w2	
 	mov		w0,ad2
 	mov 	#10,w2  	;10
 	repeat 	#17
 	div.u	w1,w2
 	mov 	w0,ad3
 	mov 	w1,ad4		
	mov		#WHITE,W8
	mov		#240,w10	;Y1
	mov		#135,W9		;X	
	mov		ad1,w11	
	add		#0x30,w11
	rcall	DrawFilledBigText		
	mov		#155,W9		;X	
	mov		ad2,w11	
	add		#0x30,w11
	rcall	DrawFilledBigText		
	mov		#175,W9		;X	
	mov		ad3,w11	
	add		#0x30,w11
	rcall	DrawFilledBigText	
	mov		#195,W9		;X	
	mov		ad4,w11	
	add		#0x30,w11
	rcall	DrawFilledBigText		
	mov		dBm,w1
	sub		#130,w1
	mov		#13,w0		;13
	mul.uu	w0,w1,w2
	mov		#89,w4
   	repeat	#17           
 	div.ud  w2,w4          
	mov		w0,w1	
 	mov 	#10,w2  	;10
 	repeat 	#17
 	div.u	w1,w2
 	mov 	w0,ad1
 	mov 	w1,ad2	
	mov		#WHITE,W8
	mov		#245,W9		;X		
	mov		#0x2d,w11
	rcall	DrawFilledBigText	
	mov		#270,W9		;X	
	mov		ad1,w11	
	add		#0x30,w11
	rcall	DrawFilledBigText		
	mov		#295,W9		;X	
	mov		ad2,w11	
	add		#0x30,w11
	rcall	DrawFilledBigText	
	mov		#340,W9		;x	
	mov		#0x64,w11
	rcall	DrawBigText	
	mov		#365,W9		;X	
	mov		#0x42,w11
	rcall	DrawBigText	
	mov		#385,W9		;X		
	mov		#0x6d,w11
	rcall	DrawBigText	
	return
;-----------------------------------------------------
__T3Interrupt:	
	retfie		
;-----------------------------------------------------
TouchTest:
	bset	LATE,#CE0
	bclr	LATE,#CE1
	call	ReadTouch       ;Read Touch Position
	cp0     W0             ;Is Pressed?
	bra     n,1f           ;no so branch
	mov		w0,temp1
	sub		w0,#0x1b0		;is it preset position
	bra		n,2f			;no so branch
	mov		w1,preangle		;get "Y" axis
;	call	predigits
2:	mov		temp1,w0
	sub		w0,#60
	bra		gt,1f
	bclr	LATE,#CE0
	bset	LATE,#CE1		
	return                  ; Return	
1:
	bclr	LATE,#CE0
	bset	LATE,#CE1		
	return                  ; Return
;--------------------------------------------------------
init_ports:
	clr     PTCON
	clr     PWMCON1
	clr     OVDCON
	clr     LATB
	clr     LATD
	clr		LATC
	clr		LATE
	mov     #0x2a,w0		;0=output 1=input
	mov     w0,TRISB
	mov     #0x00,w0
	mov     w0,TRISC
	mov     #0x00,w0
	mov     w0,TRISD
	mov     #0x00,w0
	mov.w    w0,TRISE	
	bset	LATE,#CE0
	bset	LATE,#CE1
	bset	LATE,#RST	;reset hardware
	bset	LATE,#DC
	return	
;------------------------- get AN0 value ------------------------
get_ad:
	bset	ADCON1,#ADON	;start A/D convertion
notdone:
	btss	ADCON1,#DONE	;skip if done
	goto	notdone			;not ready yet
	bclr	ADCON1,#DONE
	mov		ADCBUF1,w0
	mov		w0,adval			;GREEN REFERENCE TRACE	
	return	
;------------------------ set up A/D --------------------------
init_ad:
	mov		#0xfffc,w0	;AN0,AN1
	mov		w0,ADPCFG	;set up 2 port bits rest digital
	mov		#0x80ec,w0
	mov		w0,ADCON1
	mov		#0x0100,w0
	mov		w0,ADCON2
	mov		#0x0203,w0			;#0x0001,w0
	mov		w0,ADCON3
	mov		#0x0001,w0
	mov		w0,ADCHS
	clr		adval
	return		
;-------------- RESTORE --------
restore:
	call	index1
	TBLRDL	[w0],w4
;	mov	w4,setpoint
	call	index2
	TBLRDL	[w0],w4
	return
;------------ SAVE DATA TO EEPROM -----------
erase:
	mov		w0,NVMADR
	mov		w1,NVMADRU
	mov		#0x4044,w0
	mov		w0,NVMCON
	call	key
	return
;---------------------- 
save_ee1:
	call	index1
	call	erase
	call	index1
;	mov	setpoint,w2
	TBLWTL	w2,[w0]
	mov		#0x4004,w0
	mov		w0,NVMCON
	call	key
	return
;------------------ SAVE ONE WORD IN EERPOM -------------
key:
	DISI	#5
	mov		#0x55,w0
	mov		w0,NVMKEY
	mov		#0xaa,w1
	mov		w1,NVMKEY
	bset	NVMCON,#WR
nottdone:
	btsc	NVMCON,#WR	
	bra		nottdone
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC00)-------------------------
index1:
	mov		#0xfc00,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC02)-------------------------
index2:
	mov		#0xfc02,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;-------------------- EEPROM BOTTOM ADDRESS  (0X7FFC00)-------------------------
index:
	mov		#0xfc00,w0
	mov		#0x7f,w1
	mov		w1,TBLPAG
	return
;----------------------- MENU SET TEXT ----------
strings:
ascii	"           "
;------------------------ end of program ---------------------	
	.end
	